# Class: AbstractBeccaEntity

## AbstractBeccaEntity()

Base class for all backend entities.

## Constructor

#### new AbstractBeccaEntity()

Source:
  - becca/entities/abstract_becca_entity.js, line 18

### Members

#### (protected) becca

Source:
  - becca/entities/abstract_becca_entity.js, line 55

### Methods

#### (protected) _getContent() → {string|Buffer}

Source:
  - becca/entities/abstract_becca_entity.js, line 246

##### Returns:

Type
  string | Buffer

#### (protected) _setContent()

Source:
  - becca/entities/abstract_becca_entity.js, line 124

#### (protected) beforeSaving()

Source:
  - becca/entities/abstract_becca_entity.js, line 20

#### (protected) generateHash()

Source:
  - becca/entities/abstract_becca_entity.js, line 32

#### (protected) generateIdIfNecessary()

Source:
  - becca/entities/abstract_becca_entity.js, line 25

#### (protected) getPojoToSave()

Source:
  - becca/entities/abstract_becca_entity.js, line 76

#### (protected) getUtcDateChanged()

Source:
  - becca/entities/abstract_becca_entity.js, line 47

#### markAsDeleted(deleteIdopt)

Mark the entity as (soft) deleted. It will be completely erased later. This is a low-level method, for notes and branches use `note.deleteNote()` and 'branch.deleteBranch()` instead.

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`deleteId` |  | <optional> | null |

Source:
  - becca/entities/abstract_becca_entity.js, line 263

#### (protected) putEntityChange()

Source:
  - becca/entities/abstract_becca_entity.js, line 64

#### save() → {this}

Saves entity - executes SQL, but doesn't commit the transaction on its own

Source:
  - becca/entities/abstract_becca_entity.js, line 85

##### Returns:

Type
  this